--------------------------------------------------
-- Mir AI -> Shut Down Mod v0.1.1
--------------------------------------------------
--[[
This mod shuts down the client after some minutes of inactivity
The counter will reset when your character moves, sits down or picks an item up
--]]
--------------------------------------------------
-- HOW TO ACTIVATE THIS MOD:
-- 1. open the Control Panel,
-- 2. choose the "Extra" Tab,
-- 3. and select AutoShutDown_Mod.lua
-- (if you don't use the control panel: open SelectMod.lua and replace "Standard_Mod" with "AutoShutDown_Mod")

--------------------------------------------------
-- Extra Globals
--------------------------------------------------
SDn_StartTime = 0

-- [### CONFIG START]
SDn_TimeOut = 45 * 60000 -- milliseconds
-- [### CONFIG END]

--------------------------------------------------
function ModInit()
-- plugin initialization
--------------------------------------------------

	SDn_StartTime = GetTick()

	-- Replace standard Mir AI's functions

	StdOnIDLE_ST = OnIDLE_ST
	OnIDLE_ST = SDnOnIDLE_ST

	StdOnFOLLOW_ST = OnFOLLOW_ST
	OnFOLLOW_ST = SDnOnFOLLOW_ST

	StdOnCHASE_ST = OnCHASE_ST
	OnCHASE_ST = SDnOnCHASE_ST

	StdOnATTACK_ST = OnATTACK_ST
	OnATTACK_ST = SDnOnATTACK_ST

	StdOnEVADE_ST = OnEVADE_ST
	OnEVADE_ST = SDnOnEVADE_ST
end

--------------------------------------------------
function SDnCheck()
--------------------------------------------------
	local OwnerMotion = GetV(V_MOTION, OwnerID)
	local CurrTime = GetTick()
	if OwnerMotion == MOTION_MOVE   --\
	or OwnerMotion == MOTION_SIT    -- |- Not done by AI
	or OwnerMotion == MOTION_PICKUP --/
	then
		SDn_StartTime = CurrTime -- the user did an action: reset the timer
	else
	        if CurrTime > SDn_StartTime + SDn_TimeOut then
			os.exit(0) -- user inactive for SDn_TimeOut milliseconds: close
		end
	end
end

--------------------------------------------------
function SDnOnIDLE_ST()
--------------------------------------------------
	SDnCheck()
	StdOnIDLE_ST()
end

--------------------------------------------------
function SDnOnFOLLOW_ST()
--------------------------------------------------
	SDnCheck()
	StdOnFOLLOW_ST()
end

--------------------------------------------------
function SDnOnCHASE_ST()
--------------------------------------------------
	SDnCheck()
	StdOnCHASE_ST()
end

--------------------------------------------------
function SDnOnATTACK_ST()
--------------------------------------------------
	SDnCheck()
	StdOnATTACK_ST()
end

--------------------------------------------------
function SDnOnEVADE_ST()
--------------------------------------------------
	SDnCheck()
	StdOnEVADE_ST()
end